#ifndef __APPLICATION_H__
#define __APPLICATION_H__

#include <Ogre.h>

#include "GameEngine.h"
#include "RubyGameEngine.h"
#include "KeyboardController.h"
#include "MouseController.h"
#ifndef NO_3DMOUSE
	#include "Mouse3dConnexionController.h"
#endif
#include "ControllerConfiguration.h"
#include "Menu.h"
#include "OgreText.h"

namespace TR
{
	class Application : public Ogre::FrameListener, public Ogre::WindowEventListener
	{
	public:
		Application();
		~Application();
		void run();
		
	private:
		void loadResources();
		void createScene();
		bool frameStarted(const Ogre::FrameEvent& evt);
		bool frameEnded(const Ogre::FrameEvent& evt);
		void windowResized(Ogre::RenderWindow* rw);
		void windowClosed(Ogre::RenderWindow* rw);
		void windowFocusChange(Ogre::RenderWindow* rw);

		Ogre::Root* mRoot;
		Ogre::RenderWindow* mRenderWindow;
		GameEngine* mGameEngine;
		bool mShutdown;
		ControllerConfiguration* mController;
		Menu* mMenu;
		Ogre::SceneManager* mMenuMgr;
#ifndef NO_3DMOUSE
		Mouse3dConnexionController* mMouse3dConnexion;
#endif
		MouseController* mMouse;
		KeyboardController* mKeyboard;
	};
}

#endif