#ifndef __BUMPER_BODY_H__
#define __BUMPER_BODY_H__

#include "ObjectBody.h"
#include "Bumper.h"

namespace TR
{
	class BumperBody : public ObjectBody
	{
	public:
		BumperBody(Bumper* bumper);
		~BumperBody(void);

		void buildSceneNode(Ogre::SceneManager* sceneMgr);
		void update(double elapsedTime);
		Ogre::AxisAlignedBox getCollisionAABB() const;
		inline Ogre::AnimationState* getSpringAnimationState(){ return mSpringAnimation; }

	private:
		Bumper* mBumper;
		Ogre::AnimationState* mPropellerAnimation;
		Ogre::AnimationState* mSpringAnimation;
		Ogre::AnimationState* mIdleAnimation;
		Ogre::Entity* mCollisionEntity;

	};
}

#endif