#ifndef __COM_3DCONNEXION_H__
#define __COM_3DCONNEXION_H__

#include <string>
#include <atlstr.h>
#include "stdafx.h"

namespace TR
{
	class Com3dConnexion
	{
		enum DeviceType
		{
			UNKNOWN_DEVICE = 0,
			SPACE_EXPLORER = 4,
			SPACE_NAVIGATOR = 6,
			SPACE_TRAVELER = 25,
			SPACE_PILOT = 29
		};

	public:
		Com3dConnexion();
		~Com3dConnexion();

		bool initialize(const char* configName = 0);
		void release();

		DeviceType getDeviceType() const ;
		bool isDevicePlugged() const ;

		inline double getRotationX() const { return m3DSensor->Rotation->X; }
		inline double getRotationY() const { return m3DSensor->Rotation->Y; }
		inline double getRotationZ() const { return m3DSensor->Rotation->Z; }
		inline double getRotationAngle() const { return m3DSensor->Rotation->Angle; }

		inline double getTranslationX() const { return m3DSensor->Translation->X; }
		inline double getTranslationY() const { return m3DSensor->Translation->Y; }
		inline double getTranslationZ() const { return m3DSensor->Translation->Z; }

		inline long getKeys() const { return m3DKeyboard->Keys; }
		inline long getProgrammableKeys() const { return m3DKeyboard->ProgrammableKeys; }
		inline bool isKeyDown(long i) const { return m3DKeyboard->IsKeyDown(i) == VARIANT_TRUE; }
		inline bool isKeyUp(long i) const { return m3DKeyboard->IsKeyUp(i) == VARIANT_TRUE; }
		inline std::string getKeyName(long i) const { return std::string(m3DKeyboard->GetKeyName(i)); }

	protected:
		CComPtr<ISensor> m3DSensor;
		CComPtr<IKeyboard> m3DKeyboard;
		CComPtr<ISimpleDevice> m3DxSimpleDevice;
	};
}

#endif