#ifndef __ENVIRONMENT_H__
#define __ENVIRONMENT_H__

#include <vector>
#include "EnvironmentObject.h"
#include "GameRenderer.h"

namespace TR
{
	class Environment
	{
	public:
		Environment(GameRenderer* gr, GameEngine* gameEngine);
		virtual ~Environment();
		void update(const Ogre::Vector3& input, double elapsedTime, Ogre::Vector2 rubySpeed, double characterAltitude);
		void resolveCollisions(Object* obj);

		void showBoundingBox(bool bShow);

		inline GameEngine* getGameEngine(){ return mGameEngine; }

	protected:
		virtual void generate(double elapsedTime, Ogre::Vector2 characterSpeed, double characterAltitude);
		std::vector<EnvironmentObject*> mObjects;

		GameRenderer* mRenderer;
		bool mShowBoundingBox;
		GameEngine* mGameEngine;
	};
}

#endif
