#ifndef __GAME_ENGINE_H__
#define __GAME_ENGINE_H__

#include <Ogre.h>

#include "GameRenderer.h"
#include "Environment.h"
#include "ControllerConfiguration.h"
#include "SoundManager.h"

namespace TR
{
	class GameEngine : public Ogre::FrameListener
	{
	public:
		GameEngine();
		virtual ~GameEngine();
		
		virtual void createGame(Ogre::RenderWindow* renderWindow, Ogre::Root* root);
		virtual bool frameStarted(const Ogre::FrameEvent& evt);
		virtual bool frameEnded(const Ogre::FrameEvent& evt);
		void setControllerConfiguration(ControllerConfiguration* controller);
		inline GameRenderer* getGameRenderer(){ return mGameRenderer; }
		inline SoundManager* getSoundManager(){ return mSoundManager; }

	protected:
		GameRenderer* mGameRenderer;
		Environment* mEnvironment;
		ControllerConfiguration* mController;
		SoundManager* mSoundManager;
	};
}

#endif