#ifndef __GAME_RENDERER_H__
#define __GAME_RENDERER_H__

#include <Ogre.h>
#include <vector>

#include "ObjectBody.h"
#include "ControllerConfiguration.h"

namespace TR
{
	class GameRenderer
	{
	public:
		GameRenderer(Ogre::RenderWindow* renderWindow, Ogre::Root* root, Ogre::SceneTypeMask typeMask, const Ogre::String& instanceName);
		virtual ~GameRenderer();
		
		virtual void update(double elapsedTime);
		virtual void addToRenderQueue(ObjectBody* body);
		virtual void removeFromRenderQueue(ObjectBody* body);
		virtual inline void setCharacterBody(ObjectBody* characterBody){ mCharacterBody = characterBody; }
		inline void setControllerConfiguration(ControllerConfiguration* controller){ mController = controller; }
		inline Ogre::SceneManager* getSceneManager(){ return mSceneManager; }
		inline Ogre::SceneNode* getEarNode(){ return mEarNode; }

	protected:
		std::vector<ObjectBody*> mBodies;
		Ogre::RenderWindow* mRenderWindow;
		Ogre::Root* mRoot;
		ObjectBody* mCharacterBody;
		Ogre::SceneManager* mSceneManager;
		ControllerConfiguration* mController;
		Ogre::SceneNode* mEarNode;
	};
}

#endif