#ifndef __OBJECT_BODY_H__
#define __OBJECT_BODY_H__

#include <Ogre.h>
#include "Object.h"

namespace TR
{
	class Object;

	class ObjectBody
	{
	public:
		ObjectBody(Object* object);
		virtual ~ObjectBody(void);
		virtual void update(double elapsedTime);
		virtual void buildSceneNode(Ogre::SceneManager* sceneMgr);
		virtual void destroySceneNode(Ogre::SceneManager* sceneMgr);
		inline Ogre::SceneNode* getSceneNode(){ return mSceneNode; }
		inline const Ogre::String& getId() const { return mId; }
		virtual Ogre::AxisAlignedBox getCollisionAABB() const;
		void showBoundingBox(bool bShow);

	protected:
		Object* mObject;
		Ogre::SceneNode* mSceneNode;
		Ogre::String mId;

		static unsigned long OBJECT_ID;
	};
}

#endif
