#ifndef __PROPERTIES_H__
#define __PROPERTIES_H__

namespace TR
{
	class Properties
	{
		public:

			// Ruby properties.
			static const double MAX_INPUT_SPEED;					// Maximum speed on X and Y.
			static const double MAX_INPUT_ACCEL;					// Maximum acceleration on X and Y.
			static const double STABILITY_SPEED;					// Speed needed to stop falling.
			static const double GRAVITY_FACTOR;						// Gravity force.
			static const double MAX_ROTATION_ANGLE;					// Rotation angle (roll / pitch) when speed on X / Y is maximum (visual effect).
			static const double DUST_EFFECT_ALTI;					// Altitude limit to have a dust effect. 

			// Ruby environment properties.
			static const double ENV_AVERAGE_DISTANCE_INTERVAL;		// Average intervalle between poping objects.
			static const double ENV_POPING_DISTANCE;				// Distance, from the world 0, where objects pop when randomly generated.
			static const double ENV_RANDOM_DISTANCE;				// Maximum distance, before the poping point, where objects can pop.
			static const double ENV_WIDTH_LIMIT;					// Width limit of objects poping.
			static const double ENV_TOP_LIMIT;						// Top limit of objects poping.
			static const double ENV_BOTTOM_LIMIT;					// Bottom limit of objects poping.

			// Ruby game properties.
			static const double GAME_LENGTH;						// How long the game can be, in seconds.

			// Ruby renderer properties.
			static const double CAMERA_3_MIN_DIST;					// Minimum distance from ruby with the 3rd person camera.
			static const double CAMERA_3_MIN_ALTI;					// Minimum altitude the 3rd person camera can be.
			static const double CAMERA_1_MAX_PITCH;					// Maximum pitch of the first person camera.
			static const double CAMERA_1_MAX_YAW;					// Maximum yaw of the first person camera.

			// Ruby score manager properties.
			static const double NEAR_FLOOR_MULTIPLIER;				// Multiplier when you're under FLOOR_ALTI.
			static const double SOUND_BARRIER_MULTIPLIER;			// Multiplier when you're above SOUND_BARRIER_SPEED.
			static const double NEAR_FLOOR_ALTI;					// Bonus under this altitude.
			static const double SOUND_BARRIER_SPEED;				// Bonus above this speed (1224 km/h).

			// Sound manager properties.
			static const double INITIAL_VECTOR_SIZE;				// 
			static const double INCREASE_VECTOR_SIZE;				// 
			static const double DOPPLER_SCALE;						// 
			static const double DISTANCE_FACTOR;					// 
			static const double ROLLOFF_SCALE;						//
			static const double SOUND_3D_MIN;						// Minimum distance to hear a sound.
			static const double SOUND_3D_MAX;						// Maximum distance to hear a sound.
	};
}

#endif
