#ifndef __RUBY_H__
#define __RUBY_H__

#include "Character.h"
#include "TerrainScroller.h"

namespace TR
{
	class Ruby : public Character
	{
	public:
		Ruby(GameEngine* gameEngine);
		virtual ~Ruby();
		void updateState(const Ogre::Vector3& input,  double eslapsedTime);

		bool checkCrash(TerrainScroller* terrain);
		inline bool isNearTerrain(){ return mIsNearTerrain; }
		inline bool hasCrashed(){ return mCrashed; }

	private:
		void playCrashSound();

		void getMeshInformation(const Ogre::Mesh* const mesh,
								size_t &vertex_count,
								Ogre::Vector3* &vertices,
								size_t &index_count,
								unsigned long* &indices,
								const Ogre::Vector3 &position,
								const Ogre::Quaternion &orient,
								const Ogre::Vector3 &scale);

		Ogre::Vector3 mPreviousInputSpeed;
		bool mCrashed;
		bool mIsNearTerrain;
		double mAngleZ;
		double mAngleX;
		bool mCrashSoundPlayed;
	};
}

#endif
