#ifndef __RUBY_BODY_H__
#define __RUBY_BODY_H__

#include "ObjectBody.h"
#include "Ruby.h"

namespace TR
{
	class RubyBody : public ObjectBody
	{
	public:
		RubyBody(Ruby* ruby);
		virtual ~RubyBody(void);
		void update(double elapsedTime);
		void buildSceneNode(Ogre::SceneManager* sceneMgr);
		Ogre::AxisAlignedBox getCollisionAABB() const;

	private:
		Ruby* mRuby;
		Ogre::AnimationState* mCloakAnimation;
		Ogre::AnimationState* mFlyingAnimation;
		Ogre::ParticleSystem* mDustPS;
		Ogre::ParticleSystem* mBloodPS;
		double mDustPSEmissionRate;
		double mBloodTimer;
		Ogre::Entity* mCollisionEntity;
	};
}

#endif
