#ifndef __RUBY_GAME_ENGINE_H__
#define __RUBY_GAME_ENGINE_H__

#include "GameEngine.h"
#include "Ruby.h"
#include "RubyBody.h"
#include "SkyScroller.h"
#include "TerrainScroller.h"
#include "RubyHud.h"
#include "RubyScoreManager.h"

namespace TR
{
	class RubyGameEngine : public GameEngine
	{
	public:
		RubyGameEngine();
		virtual ~RubyGameEngine();

		virtual void createGame(Ogre::RenderWindow* renderWindow, Ogre::Root* root);
		virtual bool frameStarted(const Ogre::FrameEvent& evt);
		virtual bool frameEnded(const Ogre::FrameEvent& evt);

	private:
		Ruby* mRuby;
		SkyScroller* mSky;
		TerrainScroller* mTerrain;
		RubyHud* mHud;
		RubyScoreManager* mScoreMgr;
		double mTimer;
	};
}

#endif
