#ifndef __RUBY_HUD_H__
#define __RUBY_HUD_H__

#include <Ogre.h>

namespace TR
{
	class RubyHud
	{
	public:
		RubyHud();
		~RubyHud();

		void show(bool show);
		void update(const Ogre::Vector3& rubySpeed, double rubyAltitude, double elapsedTime, double score);
		void showGameOver(double elapsedTime);

	private:
		double mSpeed;
		double mAltitude;
		double mDistance;
		double mScore;
		double mTimer;
		double mGameOverTimer;

		Ogre::Overlay* mOverlayHud;
		Ogre::OverlayElement* mElementScore;
		Ogre::OverlayElement* mElementTimeLeft;
		Ogre::OverlayElement* mElementSpeed;
		Ogre::OverlayElement* mElementAltitude;
		Ogre::OverlayElement* mElementDistance;

		Ogre::Overlay* mOverlayEndGame;
		Ogre::OverlayElement* mElementEndScore;
		Ogre::OverlayElement* mElementEndDistance;
	};
}

#endif