#ifndef __SKY_SCROLLER_H__
#define __SKY_SCROLLER_H__

#include <Ogre.h>

namespace TR
{
	class SkyScroller
	{
	public:
		SkyScroller(const Ogre::Vector2& speed, double speedScale = 1);
		~SkyScroller();
		
		void initialize(Ogre::SceneManager* sm, const Ogre::String& material);
		void update(double elapsedTime);
		inline void setSpeed(const Ogre::Vector2& speed){ mSpeed = speed; }
		inline void setSpeedScale(double speedScale){ mSpeedScale = speedScale; }

	private:
		Ogre::TextureUnitState* mTexUnitState;
		Ogre::SceneManager* mSceneManager;
		Ogre::Vector2 mSpeed;
		double mSpeedScale;
	};
}

#endif