#include "BoosterBody.h"

namespace TR
{
	BoosterBody::BoosterBody(Booster* booster) :
		ObjectBody(booster),
		mBooster(booster),
		mAnimation(NULL),
		mCollisionEntity(NULL)
	{
	}

	BoosterBody::~BoosterBody()
	{
	}

	void BoosterBody::buildSceneNode(Ogre::SceneManager* sceneMgr)
	{
		ObjectBody::buildSceneNode(sceneMgr);

		mCollisionEntity = sceneMgr->createEntity(mId, "Booster.mesh");
		mAnimation = mCollisionEntity->getAnimationState("Rotation");
		mAnimation->setLoop(true);
		mAnimation->setEnabled(true);

		mSceneNode->attachObject(mCollisionEntity);
	}

	void BoosterBody::update(double elapsedTime)
	{
		ObjectBody::update(elapsedTime);

		mAnimation->addTime(elapsedTime);
	}

	Ogre::AxisAlignedBox BoosterBody::getCollisionAABB() const
	{
		return mCollisionEntity->getWorldBoundingBox();
	}
}