#include "BumperBody.h"

namespace TR
{
	BumperBody::BumperBody(Bumper* bumper):
		ObjectBody(bumper),
		mBumper(bumper),
		mPropellerAnimation(NULL),
		mSpringAnimation(NULL),
		mIdleAnimation(NULL),
		mCollisionEntity(NULL)
	{
	}

	BumperBody::~BumperBody(void)
	{
	}

	void BumperBody::buildSceneNode(Ogre::SceneManager* sceneMgr)
	{
		ObjectBody::buildSceneNode(sceneMgr);

		mCollisionEntity = sceneMgr->createEntity(mId, "Bumper.mesh");
		mPropellerAnimation = mCollisionEntity->getAnimationState("Rotation");
		mPropellerAnimation->setLoop(true);
		mPropellerAnimation->setEnabled(true);

		mSpringAnimation = mCollisionEntity->getAnimationState("Bump");
		mSpringAnimation->setLoop(false);
		mSpringAnimation->setEnabled(false);

		mIdleAnimation = mCollisionEntity->getAnimationState("Idle");
		mIdleAnimation->setLoop(true);
		mIdleAnimation->setEnabled(true);

		mSceneNode->attachObject(mCollisionEntity);
	}

	void BumperBody::update(double elapsedTime)
	{
		ObjectBody::update(elapsedTime);

		mPropellerAnimation->addTime(elapsedTime);
		mSpringAnimation->addTime(elapsedTime);
		mIdleAnimation->addTime(elapsedTime);
	}

	Ogre::AxisAlignedBox BumperBody::getCollisionAABB() const
	{
		return mCollisionEntity->getWorldBoundingBox();
	}
}
