#include "ControllerConfiguration.h"

namespace TR
{
	ControllerConfiguration::ControllerConfiguration() :
		mController1(NULL),
		mController2(NULL),
		mController3(NULL)
	{

	}

	ControllerConfiguration::~ControllerConfiguration()
	{

	}

	void ControllerConfiguration::prepareCapture()
	{
		if(mController1 != NULL)
			mController1->prepareCapture();

		if(mController2 != NULL && mController2 != mController1)
			mController2->prepareCapture();

		if(mController3 != NULL && mController3 != mController1 && mController3 != mController2)
			mController3->prepareCapture();
	}

	void ControllerConfiguration::capture()
	{
		if(mController1 != NULL)
		{
			mController1->captureTranslation();
			mController1->captureRotation();
			mController1->captureActions();
		}

		if(mController2 != NULL && mController2 != mController1)
		{
			mController2->captureTranslation();
			mController2->captureRotation();
			mController2->captureActions();
		}

		if(mController3 != NULL && mController3 != mController1 && mController3 != mController2)
		{
			mController3->captureTranslation();
			mController3->captureRotation();
			mController3->captureActions();
		}
	}
}
