#include "GameEngine.h"

namespace TR
{
	GameEngine::GameEngine() :
		mGameRenderer(NULL),
		mEnvironment(NULL),
		mController(NULL),
		mSoundManager(NULL)
	{
		
	}

	GameEngine::~GameEngine()
	{
		delete mGameRenderer;
		delete mEnvironment;
		delete mSoundManager;
	}

	void GameEngine::createGame(Ogre::RenderWindow* renderWindow, Ogre::Root* root)
	{
		mSoundManager = new SoundManager();
	}
	
	bool GameEngine::frameStarted(const Ogre::FrameEvent &evt)
	{
		return true;
	}

	bool GameEngine::frameEnded(const Ogre::FrameEvent &evt)
	{
		return true;
	}

	void GameEngine::setControllerConfiguration(ControllerConfiguration* controller)
	{ 
		mController = controller; 
		if(mGameRenderer != NULL) 
			mGameRenderer->setControllerConfiguration(controller);
	}
}
