#ifndef NO_3DMOUSE

#include "Mouse3dConnexionController.h"

namespace TR
{
	const double Mouse3dConnexionController::DEFAULT_3DMOUSE_SENSOR_SENSITIVITY = 280.;

	void Mouse3dConnexionController::init(Ogre::RenderWindow* window)
	{
		mComInterface.initialize("TamaxAndRuby");
	}

	void Mouse3dConnexionController::release()
	{
		mComInterface.release();
	}

	void Mouse3dConnexionController::prepareCapture()
	{

	}

	void Mouse3dConnexionController::captureTranslation()
	{
		// Scaled to 1 with the default sensivity.
		mTranslationX = mComInterface.getTranslationX() / DEFAULT_3DMOUSE_SENSOR_SENSITIVITY;
		mTranslationY = mComInterface.getTranslationY() / DEFAULT_3DMOUSE_SENSOR_SENSITIVITY;
		mTranslationZ = mComInterface.getTranslationZ() / DEFAULT_3DMOUSE_SENSOR_SENSITIVITY;

		// Clamp values.
		if(mTranslationX > 1.) mTranslationX = 1.;
		if(mTranslationX < -1.) mTranslationX = -1.;
		if(mTranslationY > 1.) mTranslationY = 1.;
		if(mTranslationY < -1.) mTranslationY = -1.;
		if(mTranslationZ > 1.) mTranslationZ = 1.;
		if(mTranslationZ < -1.) mTranslationZ = -1.;
	}

	void Mouse3dConnexionController::captureRotation()
	{
		// Axis is normalized, don't need to be scaled.
		mRotationAxisX = mComInterface.getRotationX();
		mRotationAxisY = mComInterface.getRotationY();
		mRotationAxisZ = mComInterface.getRotationZ();
		mRotationAngle = mComInterface.getRotationAngle() / DEFAULT_3DMOUSE_SENSOR_SENSITIVITY;
	}

	void Mouse3dConnexionController::captureActions()
	{

	}
}

#endif
