#include "ObjectBody.h"

namespace TR
{
	unsigned long ObjectBody::OBJECT_ID = 0;

	ObjectBody::ObjectBody(Object* object) :
		mObject(object)
	{
		std::ostringstream oss;
		oss << "OB" << OBJECT_ID++;
		mId = oss.str();
	}

	ObjectBody::~ObjectBody()
	{

	}

	void ObjectBody::update(double elapsedTime)
	{
		mSceneNode->setOrientation(mObject->getOrientation());
		mSceneNode->setPosition(mObject->getPosition());
	}

	void ObjectBody::buildSceneNode(Ogre::SceneManager* sceneMgr)
	{
		mSceneNode = sceneMgr->getRootSceneNode()->createChildSceneNode();
	}

	void ObjectBody::destroySceneNode(Ogre::SceneManager* sceneMgr)
	{
		sceneMgr->destroySceneNode(mSceneNode);
	}

	void ObjectBody::showBoundingBox(bool bShow)
	{
		mSceneNode->showBoundingBox(bShow);
	}

	Ogre::AxisAlignedBox ObjectBody::getCollisionAABB() const
	{
		return Ogre::AxisAlignedBox::BOX_NULL;
	}
}
