#include "Properties.h"

namespace TR
{
	// Ruby properties.
	const double Properties::MAX_INPUT_SPEED = 100;
	const double Properties::MAX_INPUT_ACCEL = 100.;
	const double Properties::STABILITY_SPEED = 150.;
	const double Properties::GRAVITY_FACTOR = 9.81;
	const double Properties::MAX_ROTATION_ANGLE = 50;
	const double Properties::DUST_EFFECT_ALTI = 10;

	// Ruby environment properties.
	const double Properties::ENV_AVERAGE_DISTANCE_INTERVAL = 50;
	const double Properties::ENV_POPING_DISTANCE = 500;
	const double Properties::ENV_RANDOM_DISTANCE = 20;
	const double Properties::ENV_WIDTH_LIMIT = 100;
	const double Properties::ENV_TOP_LIMIT = 200;
	const double Properties::ENV_BOTTOM_LIMIT = 10;

	// Ruby game properties.
	const double Properties::GAME_LENGTH = 90; // 1 min 30 sec

	// Ruby renderer properties.
	const double Properties::CAMERA_3_MIN_DIST = 3;
	const double Properties::CAMERA_3_MIN_ALTI = 6;
	const double Properties::CAMERA_1_MAX_PITCH = 100;
	const double Properties::CAMERA_1_MAX_YAW = 165;	

	// Ruby score manager properties.
	const double Properties::NEAR_FLOOR_MULTIPLIER = 2;
	const double Properties::SOUND_BARRIER_MULTIPLIER = 10;
	const double Properties::NEAR_FLOOR_ALTI = 10;
	const double Properties::SOUND_BARRIER_SPEED = 340.; //(1224 km/h)

	// Sound manager properties.
	const double Properties::INITIAL_VECTOR_SIZE = 100;
	const double Properties::INCREASE_VECTOR_SIZE = 20;
	const double Properties::DOPPLER_SCALE = 0.2;
	const double Properties::DISTANCE_FACTOR = 1.0;
	const double Properties::ROLLOFF_SCALE = 0.5;

	const double Properties::SOUND_3D_MIN = 50.;
	const double Properties::SOUND_3D_MAX = 2000.;
}
