#include "RubyScoreManager.h"
#include "Properties.h"

namespace TR
{
	RubyScoreManager::RubyScoreManager() :
		mTotalScore(0),
		mTimer(0),
		mDistance(0),
		mMultiplier(1)
	{

	}

	void RubyScoreManager::update(const Ogre::Vector3& rubySpeed, double rubyAltitude, double elapsedTime)
	{
		mTimer += elapsedTime;
		mDistance += rubySpeed.z * elapsedTime;

		// Calculate score every 0.2 second.
		// delta score = multiplier * delta distance * instant speed / 100
		if(mTimer > 0.2)
		{			
			mMultiplier = 1;

			if(rubyAltitude < Properties::NEAR_FLOOR_ALTI)
				mMultiplier *= Properties::NEAR_FLOOR_MULTIPLIER;

			if(rubySpeed.z > Properties::SOUND_BARRIER_SPEED)
				mMultiplier *= Properties::SOUND_BARRIER_MULTIPLIER;

			mTotalScore += mMultiplier * mDistance * rubySpeed.z / 100. ;

			mTimer -= 0.2;
			mDistance = 0;
		}
	}
}
