#include "SkyScroller.h"

using namespace Ogre;

namespace TR
{
	SkyScroller::SkyScroller(const Ogre::Vector2& speed, double speedScale) :
		mTexUnitState(NULL),
		mSceneManager(NULL)
	{
		mSpeed = speed;
		mSpeedScale = speedScale;
	}

	SkyScroller::~SkyScroller()
	{
	
	}

	void SkyScroller::initialize(Ogre::SceneManager* sm, const Ogre::String& material)
	{
		mSceneManager = sm;
		Ogre::Plane plane(0, -1, 0, 15);
		sm->setSkyPlane(true, plane, material, 100, 70, true, 0.5, 150, 150);	
		
		mTexUnitState = static_cast<Ogre::MaterialPtr>(Ogre::MaterialManager::getSingleton().getByName(material))
																								->getTechnique(0)
																								->getPass(0)
																								->getTextureUnitState(0);
	}

	void SkyScroller::update(double elapsedTime)
	{
		static double i = 0;
		static double j = 0;
		
		double distance_x = mSpeed.x * elapsedTime;
		i += distance_x * mSpeedScale;
		if(i>1) i-=1;

		double distance_z = mSpeed.y * elapsedTime;
		j += distance_z * mSpeedScale;
		if(j>1) j-=1;

		if(mTexUnitState != NULL)
		{
			mTexUnitState->setTextureUScroll(i);
			mTexUnitState->setTextureVScroll(j);
		}
	}
}
