#include "Slower.h"
#include "SlowerBody.h"
#include "GameEngine.h"
#include "Properties.h"

namespace TR
{
	Slower::Slower(GameEngine* gameEngine):
		EnvironmentObject(gameEngine),
		mActivated(false)
	{
		mBody = new SlowerBody(this);
		mSoundChannel = 1;
	}

	Slower::~Slower()
	{
		mGameEngine->getSoundManager()->StopSound(&mSoundChannel);
	}

	void Slower::onCollide(Object* obj)
	{
		if(!mActivated)
		{
			obj->accelerate(Ogre::Vector3(0,0,-50));
			
			int sound = mGameEngine->getSoundManager()->CreateSound(Ogre::String("slow.ogg"), SOUND_TYPE_3D_SOUND);
			mGameEngine->getSoundManager()->PlaySound(sound, mBody->getSceneNode(), &mSoundChannel);
			mGameEngine->getSoundManager()->Set3DMinMaxDistance(mSoundChannel, Properties::SOUND_3D_MIN, Properties::SOUND_3D_MAX);
			
			mActivated = true;
		}
	}
}