#include "StopperBody.h"

namespace TR
{
	StopperBody::StopperBody(Stopper* stopper) :
		ObjectBody(stopper),
		mStopper(stopper),
		mAngel1Animation(NULL),
		mAngel2Animation(NULL),
		mAngel3Animation(NULL),
		mCollisionEntity(NULL)
	{
	}

	StopperBody::~StopperBody()
	{
	}

	void StopperBody::buildSceneNode(Ogre::SceneManager* sceneMgr)
	{
		ObjectBody::buildSceneNode(sceneMgr);

		Ogre::Entity* entity = sceneMgr->createEntity(mId, "Glass.mesh");
		mSceneNode->attachObject(entity);
		mCollisionEntity = entity;
		
		entity = sceneMgr->createEntity(mId.append("_1"), "Angel01.mesh");
		mAngel1Animation = entity->getAnimationState("Feather");
		mAngel1Animation->setLoop(true);
		mAngel1Animation->setEnabled(true);
		mSceneNode->attachObject(entity);

		entity = sceneMgr->createEntity(mId.append("_2"), "Angel02.mesh");
		mAngel2Animation = entity->getAnimationState("Feather");
		mAngel2Animation->setLoop(true);
		mAngel2Animation->setEnabled(true);
		mSceneNode->attachObject(entity);

		entity = sceneMgr->createEntity(mId.append("_3"), "Angel03.mesh");
		mAngel3Animation = entity->getAnimationState("Feather");
		mAngel3Animation->setLoop(true);
		mAngel3Animation->setEnabled(true);
		mSceneNode->attachObject(entity);
	}

	void StopperBody::update(double elapsedTime)
	{
		ObjectBody::update(elapsedTime);

		mAngel1Animation->addTime(elapsedTime * 3);
		mAngel2Animation->addTime(elapsedTime * 3);
		mAngel3Animation->addTime(elapsedTime * 3);
	}

	Ogre::AxisAlignedBox StopperBody::getCollisionAABB() const
	{
		return mCollisionEntity->getWorldBoundingBox();
	}
}