#include <Ogre.h>

#include "Application.h"

#if OGRE_PLATFORM == OGRE_PLATFORM_WIN32
#define WIN32_LEAN_AND_MEAN
#include "windows.h"

	INT WINAPI WinMain(HINSTANCE hInst, HINSTANCE, LPSTR strCmdLine, INT)
#else
	int main(int argc, char **argv)
#endif
{
    try
	{
#ifndef NO_3DMOUSE
		// Initialize COM system
		HRESULT hr=::CoInitializeEx(NULL, COINIT_APARTMENTTHREADED );
		if (!SUCCEEDED(hr))
		{
			CString strError;
			strError.FormatMessage (_T("Error 0x%x"), hr);
			::MessageBox (NULL, strError, _T("CoInitializeEx failed"), MB_ICONERROR|MB_OK);
			return FALSE;
		}
#endif

		TR::Application app;
		app.run();
    }
	catch(Ogre::Exception &e)
	{
#if OGRE_PLATFORM == OGRE_PLATFORM_WIN32
		MessageBox(NULL, e.what(), "An exception has occurred!", MB_OK | MB_ICONERROR | MB_TASKMODAL);
#else
        fprintf(stderr, "An exception has occurred: %s\n",e.what());
#endif
	}
	return 0;
}
				
